﻿using Syncfusion.SfBusyIndicator.XForms;
using Syncfusion.SfDataGrid.XForms;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Forms;
using YPS.ViewModel;

namespace DemoPro
{
    public partial class MainPage : ContentPage
    {
        SfBusyIndicator indicator;
        public MainPage()
        {
            InitializeComponent();

            indicator = new SfBusyIndicator();
            BindingContext  = new PoDataViewModel(Navigation);
        }

        private async void DataGrid_GroupExpanding(object sender, GroupChangingEventArgs e)
        {

            indicator.IsBusy = true;
            indicator.IsVisible = true;

            indicator.AnimationType = AnimationTypes.SlicedCircle;
            await Task.Delay(1000);
            grid.Children.Add(indicator);

            indicator.IsBusy = false;
            indicator.IsVisible = false;

        }


        private void DataGrid_QueryCellStyle(object sender, QueryCellStyleEventArgs e)
        {

            try
            {
                if (dataGrid.SelectedItems.Contains(e.RowData))
                {
                    if (e.ColumnIndex == 0)
                        e.Style.BackgroundColor = Color.FromHex("#0300ef");

                }

                e.Style.CellStylePreference = StylePreference.StyleAndSelection;
                e.Handled = true;
            }
            catch (Exception ex)
            {

            }
        }

    }
}
