﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Runtime.CompilerServices;
using System.Text;

namespace DemoPro.Model
{
    public class SendPodata
    {
        public int UserID { get; set; }
        public string PONumber { get; set; }
        public string REQNo { get; set; }
        public string ShippingNo { get; set; }
        public int DisciplineID { get; set; }
        public int ELevelID { get; set; }
        public string Condition { get; set; }
        public string Expeditor { get; set; }
        public int PriorityID { get; set; }
        public string LocationPickup { get; set; }
        public string LocationPOL { get; set; }
        public string LocationPOD { get; set; }
        public int LocationOnsite { get; set; }
        public string Pickup { get; set; }
        public string POL { get; set; }
        public string POD { get; set; }
        public int Onsite { get; set; }
        public string CountyPickup { get; set; }
        public string CountyPOL { get; set; }
        public string CountyPOD { get; set; }
        public int CountyOnsite { get; set; }
        public string PickupFrom { get; set; }
        public string PickupTo { get; set; }
        public string POLFrom { get; set; }
        public string POLTo { get; set; }
        public string PODFrom { get; set; }
        public string PODTo { get; set; }
        public string OnsiteFrom { get; set; }
        public string OnsiteTo { get; set; }
    }

    public class AllPoData : INotifyPropertyChanged
    {
        #region Properties
        // for mobile cell
        public string emptyCellValue { get; set; } = string.Empty;

        public string ShippingNumber { get; set; }
        public string DisciplineName { get; set; }
        public string ELevelName { get; set; }
        public string PONumber { get; set; }
        public string REQNo { get; set; }
        public string PODescription { get; set; }
        public string SupplierCompanyName { get; set; }
        public string ManufacturerCompanyName { get; set; }
        public string CompanyName { get; set; }
        public string ProjectName { get; set; }
        public string CountryName { get; set; }
        public string PriorityName { get; set; }
        public string Expediter { get; set; }
        public int PLUploadCount { get; set; }
        public int Unit { get; set; }
        public double M3 { get; set; }
        public double Kgs { get; set; }
        public int QACount { get; set; }
        public int FileCount { get; set; }
        public int BPhotoCount { get; set; }
        public int APhotoCount { get; set; }
        public int TagsPrintCount { get; set; }
        public int POID { get; set; }
        public int POTagID { get; set; }
        public string POShippingNumber { get; set; }

        public string TagNumber { get; set; }
        public string TagDescription { get; set; }
        public int TagQACount { get; set; }
        public int PUID { get; set; }
        public int TagBPhotoCount { get; set; }
        public int TagAPhotoCount { get; set; }
        public int FUID { get; set; }
        public int TagFilesCount { get; set; }
        public int TagQAClosedCount { get; set; }
        public string POIssue { get; set; }
        public string KOM { get; set; }
        public string KeyDWGReceived { get; set; }
        public string KeyDWGReturned { get; set; }
        public string MainMaterialSubOrderIssue { get; set; }
        public string MainMaterialReceived { get; set; }
        public string FABStart { get; set; }
        public string IRN { get; set; }
        public string DeliveryDate { get; set; }
        public string PortArrival { get; set; }
        public string SiteArrival { get; set; }
        public string FinalDocument { get; set; }
        public string PIM { get; set; }
        public string ROS { get; set; }
        public int ISFileClosed { get; set; }
        public int ISPhotoClosed { get; set; }
        public int ISFinalVol { get; set; }
        public int IsPhotoRequired { get; set; }

        #endregion

        #region Fields for Mobile 
        public bool ForMultiCheck { set; get; } = false;
        public string chatImage { set; get; }
        public bool chatTickVisible { set; get; }
        public bool photoTickVisible { set; get; }
        public bool fileTickVisible { set; get; }
        public bool countVisible { set; get; }

        public string cameImage { set; get; }
        public string fileImage { set; get; }
        public bool filecountVisible { set; get; }
        public bool APhotoCountVisible { set; get; }
        public bool BPhotoCountVisible { set; get; }

        private bool _isClosed;
        public bool IsClosed
        {
            get
            {
                return _isClosed;
            }
            set
            {
                this._isClosed = value;
                RaisePropertyChanged("IsClosed");
            }
        }
        //public string boolImage { set; get; } = "unchecked_ic.png";
        #endregion

        #region INotifyPropertyChanged Implimentation
        public event PropertyChangedEventHandler PropertyChanged;
        public virtual void NotifyPropertyChanged([CallerMemberName] string propertyName = null)
        {
            var handler = PropertyChanged;
            if (handler != null) handler(this, new PropertyChangedEventArgs(propertyName));
        }
        public void RaisePropertyChanged(String name)
        {
            if (PropertyChanged != null)
                this.PropertyChanged(this, new PropertyChangedEventArgs(name));
        }
        #endregion

    }

    public class GetPoData
    {
        public string message { get; set; }
        public int status { get; set; }
        public ObservableCollection<AllPoData> data { get; set; }

        public GetPoData()
        {
            data = new ObservableCollection<AllPoData>();
        }

    }

}
