﻿using DemoPro.Model;
using DemoPro.RestClientAPI;
using Newtonsoft.Json;
using Syncfusion.Data;
using Syncfusion.SfDataGrid.XForms;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Input;
using Xamarin.Forms;

namespace YPS.ViewModel
{
    public class PoDataViewModel : INotifyPropertyChanged
    {

        public INavigation Navigation { get; set; }

        //public ICommand tap_InitialCameraCommand { set; get; }
        //public ICommand tap_OnMessageCommand { set; get; }
        //public ICommand tap_InitialFileUploadCommand { set; get; }
        //public ICommand tap_OnFilterCommand { get; set; }
        //public ICommand tap_PrinterCommand { get; set; }
        //public ICommand tap_PLfileGroupCommand { get; set; }
        //public ICommand tap_ShipMarkPrinterCommand { get; set; }


        //public ICommand tap_OnChat { get; set; }
        //public ICommand tap_OnCamB { get; set; }
        //public ICommand tap_OnCamA { get; set; }
        //public ICommand tap_FileUpload { get; set; }

        //public ICommand ChooseColumns_Tap { get; set; }
        //public ICommand btn_close { get; set; }
        //public ICommand btn_done { get; set; }
        //public ICommand profile_Change_Tap { get; set; }
        //public ICommand IsRequired_Tap_IC { get; set; }
        //public ICommand IsNotRequired_Tap_IC { get; set; }

        public PoDataViewModel(INavigation _Navigation)
        {
            Navigation = _Navigation;
            GetData();
            //GetColumnsData();
            //var cID = Settings.CompanyID;
            //var pID = Settings.ProjectID;
            //var jID = Settings.JobID;

            //tap_InitialCameraCommand = new Command(tap_InitialCamera);
            //tap_OnMessageCommand = new Command(tap_OnMessage);
            //tap_InitialFileUploadCommand = new Command(tap_InitialFileUpload);
            //tap_OnFilterCommand = new Command(async () => await FilterClicked());

            //tap_OnChat = new Command(tap_eachMessage);
            //tap_OnCamB = new Command(tap_eachCamB);
            //tap_OnCamA = new Command(tap_eachCamA);
            //tap_FileUpload = new Command(tap_eachFileUpload);
            //tap_PrinterCommand = new Command(tap_Printer);
            //tap_PLfileGroupCommand = new Command(tap_plFileUpload);
            //tap_ShipMarkPrinterCommand = new Command(tap_shipmarkPrinter);
            //ChooseColumns_Tap = new Command(ChooseColumns);
            //btn_close = new Command(closeBtn);
            //btn_done = new Command(doneBtn);
            //profile_Change_Tap =new Command(profile_Tap);
            //IsRequired_Tap_IC = new Command(IsRequired_Tap);
            //IsNotRequired_Tap_IC = new Command(IsNotRequired_Tap);
        }

        public async void GetData()
        {
            try
            {
                RestClient service = new RestClient();

                SendPodata sendPodata = new SendPodata();
                sendPodata.UserID = 6;

                #region apply the filter condition with selected values

                #region header values
                sendPodata.PONumber = ""; //Settings.PONumber;
                sendPodata.REQNo = ""; //Settings.REQNo;
                sendPodata.ShippingNo = ""; //Settings.ShippingNo;
                sendPodata.DisciplineID = 0;// Settings.DisciplineID;  //need to pass id
                sendPodata.ELevelID = 0;// Settings.ELevelID;//need to pass id
                sendPodata.Condition = "";// Settings.Condition;
                sendPodata.Expeditor = "";// Settings.Expeditor;
                sendPodata.PriorityID = 0;// Settings.PriorityID; //need to pass id
                #endregion

                #region location values
                //sendPodata.LocationPickup = Settings.LocationPickup;
                //sendPodata.LocationPOL = Settings.LocationPOL;
                //sendPodata.LocationPOD = Settings.LocationPOD ;
                //sendPodata.LocationOnsite = Settings.LocationOnsite; //need to pass id
                #endregion

                #region country values
                //sendPodata.CountyPickup = Settings.CountyPickup;
                //sendPodata.CountyPOL = Settings.CountyPOL ;
                //sendPodata.CountyPOD = Settings.CountyPOD ;
                //sendPodata.CountyOnsite = Settings.CountyOnsite;//need to pass id
                #endregion

                #region dates values
                sendPodata.PickupFrom = "";// Settings.PickupFrom;
                sendPodata.POLFrom = "";//Settings.POLFrom;
                sendPodata.PODFrom = "";// Settings.PODFrom;
                sendPodata.OnsiteFrom = "";// Settings.OnsiteFrom;//need to pass id
                sendPodata.PickupTo = "";// Settings.PickupTo;
                sendPodata.POLTo = "";// Settings.POLTo;
                sendPodata.PODTo = "";// Settings.PODTo;
                sendPodata.OnsiteTo = "";// Settings.OnsiteTo;//need to pass id
                #endregion

                #endregion

                var poData = await service.LoadPoData(sendPodata);


                var result = JsonConvert.DeserializeObject<GetPoData>(poData.ToString());

                if (result.status != 0)
                {
                    foreach (var data in result.data)
                    {


                        #region Chat
                        if (data.TagQACount == 0)
                        {
                            if (data.TagQAClosedCount > 0)
                            {
                                data.chatImage = "chatIcon.png";
                                data.chatTickVisible = true;
                            }
                            else
                            {
                                data.chatImage = "minus.png";
                            }
                        }
                        else
                        {
                            data.chatImage = "chatIcon.png";
                            data.countVisible = true;
                        }

                        #endregion

                        #region Before Photo & After Photo
                        if (data.TagBPhotoCount == 0 && data.TagAPhotoCount == 0)
                        {
                            if (data.IsPhotoRequired == 0)
                                data.cameImage = "cross.png";
                            else
                                data.cameImage = "minus.png";
                        }
                        else
                        {
                            if (data.ISPhotoClosed == 1)
                            {
                                data.cameImage = "Chatcamera.png";
                                data.photoTickVisible = true;
                            }
                            else
                            {
                                data.cameImage = "Chatcamera.png";
                                data.BPhotoCountVisible = true;
                                data.APhotoCountVisible = true;
                            }
                        }
                        #endregion

                        #region File upload 
                        if (data.TagFilesCount == 0)
                        {
                            data.fileImage = "minus.png";
                        }
                        else
                        {
                            if (data.ISFileClosed > 0)
                            {
                                data.fileImage = "attachb.png";
                                data.fileTickVisible = true;
                            }
                            else
                            {
                                data.fileImage = "attachb.png";
                                data.filecountVisible = true;
                            }
                        }
                        #endregion

                    }

                    PoDataCollections = result.data;

                }
                else
                {

                }
            }
            catch (Exception ex)
            {
            }

           // popup =false;
        }



        #region INotifyPropertyChanged Implimentation
        public event PropertyChangedEventHandler PropertyChanged;
        public virtual void NotifyPropertyChanged([CallerMemberName] string propertyName = null)
        {
            var handler = PropertyChanged;
            if (handler != null) handler(this, new PropertyChangedEventArgs(propertyName));
        }
        public void RaisePropertyChanged(String name)
        {
            if (PropertyChanged != null)
                this.PropertyChanged(this, new PropertyChangedEventArgs(name));
        }
        #endregion

        #region Properties

        private ObservableCollection<AllPoData> _PoData; 
        public ObservableCollection<AllPoData> PoDataCollections
        {
            get { return _PoData; }
            set
            {
                _PoData = value;
                RaisePropertyChanged("PoDataCollections");
            }
        }

      
        private bool _profileSettingVisible = false;
        public bool profileSettingVisible
        {
            get { return _profileSettingVisible; }
            set
            {
                _profileSettingVisible = value;
                RaisePropertyChanged("profileSettingVisible");
            }
        }

        private bool _activityIndicator; 
        public bool activityIndicator
        {
            get { return _activityIndicator; }
            set
            {
                _activityIndicator = value;
                RaisePropertyChanged("activityIndicator");
                //NotifyPropertyChanged();
            }
        }

        private bool _popup = false;
        public bool popup
        {
            get { return _popup; }
            set
            {
                _popup = value;
                NotifyPropertyChanged();
            }
        }

        private bool _columnsStack = false;
        public bool columnsStack
        {
            get { return _columnsStack; }
            set
            {
                _columnsStack = value;
                NotifyPropertyChanged();
            }
        }

        private bool _mainStack = true; 
        public bool mainStack
        {
            get { return _mainStack; }
            set
            {
                _mainStack = value;
                NotifyPropertyChanged();
            }
        }

    
        private bool _collapseVisible = true; 
        public bool collapseVisible
        {
            get { return _collapseVisible; }
            set
            {
                _collapseVisible = value;
                NotifyPropertyChanged();
            }
        }

        #endregion
    }

  
}
